# -*- coding: utf-8 -*-
##############################################################################
#
#    Author: Joël Grand-Guillaume
#    Copyright 2013 Camptocamp SA
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import orm, fields


class magento_stock_picking(orm.Model):
    _name = 'magento.stock.picking.out'
    _inherit = 'magento.binding'
    _inherits = {'stock.picking': 'openerp_id'}

    _columns = {
        'openerp_id': fields.many2one('stock.picking.out',
                                      string='Stock Picking',
                                      required=True,
                                      ondelete='cascade'),
        'magento_order_id': fields.many2one('magento.sale.order',
                                            string='Magento Sale Order',
                                            ondelete='set null'),
        'picking_method': fields.selection([('complete', 'Complete'),
                                            ('partial', 'Partial')],
                                           string='Picking Method',
                                           required=True),
    }

    _sql_constraints = [
        ('magento_uniq', 'unique(backend_id, magento_id)',
         'A stock picking with same ID on Magento already exists.'),
    ]


class stock_picking(orm.Model):
    _inherit = 'stock.picking.out'

    _columns = {
        'magento_bind_ids': fields.one2many(
            'magento.stock.picking.out', 'openerp_id',
            string="Magento Bindings"),
    }

